#! /usr/bin/env python
# coding: utf-8
# 青空文庫htmlのMobipocketReader用タグ変換処理スクリプト
# AoMobi.py coded by Leonapapa '10.03.31
#
"""
Original program(AoMobi.py) was written by Mr. Leonapapa. (See upper part)
I changed it and added some function for myself. So I change the name
of this Apps. to PyAoMobi.py.
I appreciate to Mr. Leonapapa.
-----------------
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.
"""
__script__ = "PyAoMobi"
__ver__    = "0.01(2)"
__author__ = 'Leonapapa & masa'
__web__    = "http://masaland.cocolog-nifty.com/"
__Copyright__ = 'Copyright (c) 2010 Leonapapa & masa'
__Copyr__ = '(C) 2010 masa'

import sys
sys.setdefaultencoding('utf-8')
sys.path.insert(0, 'E:\\Python\\lib')

#***** option, change this when you need  ******
Default_dir_in  = 'E:/Library'
Default_dir_out = 'E:/eBooks'

In_file = 'E:/Library/Bookin.htm'
Out_file = 'E:/eBooks/Bookout.htm'
#***********************************************

import re
import codecs
import os
import e32
import appuifw

Debug = 0
if Debug: import traceback

try:
    import japanese
    JP_CODECS = 1
except:
    JP_CODECS = 0

try:
    from PyFbuiutil import Fbrowser
    from PyFbuiutil import Getpath
    Gpath = Getpath()
    FBUIUTIL = 1
except:
    FBUIUTIL = 0

#ルビタグ<ruby>変換処理
def ruby_tag(s):
    t = re.compile(r'<\s*/*\s*ruby\s*>', re.I).split(s)
    if (len(t) % 2) == 0 : return s,1  #ルビタグ未完結
    for i in range(len(t)//2) :
        #ルビ・対象漢字抽出
        kanji = re.compile('<\s*rb\s*>(.*?)<\s*/\s*rb\s*>', re.I).search(t[2*i+1]).group(1)
        yomi  = re.compile('<\s*rt\s*>(.*?)<\s*/\s*rt\s*>', re.I).search(t[2*i+1]).group(1)
        #例外処理（ルビ中外字画像処理）
        m = re.compile('^(.*?)<\s*img.+?alt\s*=\s*".*?(.*?)".*?>(.*?)$', re.I).match(kanji)
        if m:
            text = m.group(2)
            if m.group(1)!="" : text = m.group(1) + unicode('＋') + text
            if m.group(3)!="" : text = text + unicode('＋') + m.group(3)
            kanji = unicode('※') + yomi
            yomi = text
        #アンカータグ(title)へ変換
        t[2*i+1] = '<a title="'+yomi+'">'+  kanji + '</a>'
    return "".join(t),0

#入力者注釈タグ<span class="notes">変換処理
def span_tag(s):
    t = re.compile(r'<\s*/*\s*span\s*.*?>', re.I).split(s)
    if (len(t) % 2) == 0 : return s,1  #注釈タグ未完結
    for i in range(len(t)//2) :
        #注釈抽出
        m = re.compile(unicode('^.*?［＃(.*?)］'), re.I).match(t[2*i+1])
        if m:
            chushaku = m.group(1)
            m1 = re.compile('^(.*?)<\s*img.+?alt\s*=\s*".*?(.*?)".*?>(.*?)$', re.I).match(chushaku)
            m2 = re.match(unicode('^.*?「(.*?)」.*?傍点.*'),chushaku)
            #改ページ変換処理
            if chushaku==unicode('改ページ') or chushaku==unicode('改頁') or chushaku==unicode('改丁') or chushaku==unicode('改段'):
                t[2*i+1] = '<mbp:pagebreak/>'
                t[2*i+2] = '\n'
            #例外処理（入力者注釈中外字処理）
            elif m1 :
                text = m1.group(2)
                if m1.group(1)!="" : text = m1.group(1) + unicode('＋') + text
                if m1.group(3)!="" : text = text + unicode('＋') + m1.group(3)
                t[2*i+1] = '<a title="' + text + '">' + unicode('※') + '</a>'
            #傍点処理（強調文字に変換）
            elif m2 :
                text = m2.group(1)
                t[2*i+1] = '<strong class="SESAME_DOT">' + text + '</strong>'
                lt2i = len(t[2*i])
                ltext = len(text)
                if lt2i>=ltext : t[2*i]=t[2*i][:lt2i-ltext]
            #一般注釈処理（アンカータグへ変換）
            else :
                t[2*i+1] = '<a title="' + chushaku + '">' + unicode('※') + '</a>'
        #規約外注釈処理（アンカータグに変換）
        else :
            t[2*i+1] = '<a title="' + t[2*i+1] + '">' + unicode('※') + '</a>'
    #一般外字画像タグ<img>処理（アンカータグに変換）
    text = "".join(t)
    img_ptn = re.compile(u'<\s*img..*?>', re.I)
    img_clm = img_ptn.search(text) #< img......>を抽出
    while img_clm:
        st_p = img_clm.start()
        sp_p = img_clm.end()
        s1  = text[:st_p]
        sm  = text[st_p:sp_p]
        s2  = text[sp_p:]
        #<img... alt...> altがあるかチェック、あれば処理し、なければ捨てる
        m = re.compile('^<\s*img.+?alt\s*=\s*".*?(.*?)".*?>',re.I).match(sm) 
        if m:
            sm = '<a title="' + m.group(1) + '">' + unicode('※') + '</a>'
            text = s1 + sm + s2
        else:
            text = s1 + unicode('※') + s2
        img_clm = img_ptn.search(text) #< img......>を抽出
    return text,0


#字下げタグ<div class="jisage">処理
#地着きタグ<div class="chitsuki">処理
#文庫情報タグ<div class="bibliographical_information">前の改ページ処理


#charsetのShift-JIS を　UTF-16に変える。
def replace_charset(s):
    ptn = re.compile('charset\s*?=..*?jis', re.I)
    text = ptn.sub('charset=UTF-16', s)
    return text


#メイン
def aomobis60(file,file2):
    buff = ""
    try:
        #入力ファイル設定（青空文庫ファイルはshift-jis）
        f = codecs.open(file,'r','shift-jis')
        #f = codecs.open(file,'r','utf-16')
        #出力ファイル設定（出力は常にUnicode）
        opf = codecs.open(file2,'wb','utf-16')
    except:
        show_er_val()
        return 1 #1: error
    try:
        #タグ変換処理（一行毎処理）
        cnt = 0 # line count, use when replace charset
        line = f.readline()
        while line :
            line = buff + line
            #ルビタグ処理呼び出し
            line, ierror = ruby_tag(line)
            if ierror == 1 : #ルビタグ未完結時の次行読み
                buff = line
            else:
                #入力者注釈タグ処理呼び出し
                line, ierror2 = span_tag(line)
                if ierror2 == 1 : #注釈タグ未完結時の次行読み
                    buff = line
                else: #タグ処理終了書込み
                    if cnt < 50:
                        line = replace_charset(line)
                        cnt = cnt + 1
                    buff = ""
                    opf.write(line)
            line = f.readline()
        #ファイルクローズ
        f.close()
        opf.close()
        return 0 #0: no error
    except:
        show_er_val()
        return 1 #1: error


def show_er_val():
    import sys
    type, value = sys.exc_info() [:2]
    rtn = appuifw.query(unicode(str(type)+'\n'+str(value)), 'query')
    if Debug:
        traceback.print_tb(sys.exc_info() [2])


def main():
    global FBUIUTIL
    global Gpath
    global JP_CODECS
    global In_file
    global Out_file
    if not JP_CODECS: # no Shift-JIS codec
        appuifw.query(u'Shift-JIS codec not exist\nplease inatall it', 'query')
        return
    while True:
        appuifw.app.title = unicode(__script__ ) + u' v' + unicode(__ver__)
        screen = appuifw.Text()
        screen.color = 0x000000
        screen.set(u"\n  PyAoMobi")
        appuifw.app.body = screen
        e32.ao_yield()

        if FBUIUTIL :
            open_path = Gpath.get_read_path(title="Select input file", default_path = Default_dir_in)
            if open_path == None:
                #return
                break
            #open_path = unicode(open_path)
            dir_path ,file_name = os.path.split(open_path) #[0]

            save_dest = Gpath.get_write_path(title='Output file path', \
                         default_path=Default_dir_out, msg_ex=file_name)
            if save_dest == None:
                #return
                break
            #save_dest = unicode(save_dest)

            In_file  = open_path
            Out_file = save_dest
        else:
            if not os.path.exists(In_file):
                appuifw.query(u'In_file not exist\nplease check it', 'query')
                break
            if not appuifw.query(u'Convert In_file ?\nOK -> convert\nCancel -> Exit', 'query'):
                break
        screen.set(u"\n  PyAoMobi\n  coverting...")
        #appuifw.app.body = screen
        e32.ao_yield()

        rtn = aomobis60(In_file, Out_file)
        if rtn: #return 1 = error occured
            break
        else:
            appuifw.query(u'successfully converted', 'query')
            if not FBUIUTIL: #no FBUIUTIL -> convert only In_file
                break


#起動（引数は青空文庫HTMLファイルと出力ファイル）
if __name__ == '__main__': main()

#appuifw.app.set_exit()
#sys.exit()

